;-- ein kleines Skript, welches den Schnellstart verschiedener Programme (inkl mglicher Parameter) ermglicht
;-- das Skript und damit die Programme werden mit den Rechten des aktuellen Benutzers gestartet

-- Parameter setzen
SetTitleMatchMode, 2   ;-- Fenstertitelmodus ndern (Autohotkey Doku)
pfad_ordner = %A_AppData%\schnellstart
pfad_eintraege = %A_AppData%\schnellstart\pfade.ini
pfad_backup = %A_AppData%\schnellstart\backup.ini

;-- sicherstellen, dass der Config Ordner und die Config Datei vorhanden sind bzw die Backup Datei nicht vorhanden ist
IfNotExist, %pfad_ordner%
{
 FileCreateDir, %pfad_ordner%
 if(errorlevel != 0)
 {
  Msgbox, 0, Fehler, Der Ordner %pfad_ordner% konnte nicht erstellt werden.
  exitapp
 }
}
IfNotExist, %pfad_eintraege%
{
 FileAppend, , %pfad_eintraege%
 if(errorlevel != 0)
 {
  Msgbox, 0, Fehler, Die Datei %pfad_eintraege% konnte nicht erstellt werden.
  exitapp
 }
}
IfExist, %pfad_backup%
{
 FileDelete, %pfad_backup%
 if(errorlevel != 0)
 {
  Msgbox, 0, Fehler, Die Datei %pfad_backup% existiert bereits und konnte nicht gelscht werden.
  exitapp
 }
}

;-- erstelle GUI
Gui, Add, ListView, r20 w800 sort vliste, Name|Pfad|Parameter
Gui, add, Button, default section, &Starten
Gui, add, Button, ys, &Neu
Gui, add, Button, ys, &Lschen
listeAktualisieren(pfad_eintraege)
Gui, Show,,Als %A_UserName% ausfhren
return

guiclose:
GuiEscape:
exitapp
return

ButtonStarten:
markierteZeile := LV_getNext()
if(markierteZeile <= 0)
 msgbox, 0, Fehler, Nichts markiert.
else
{
;-- Parameter an Variablen bergeben
 LV_getText(name, markierteZeile, 1)
 LV_getText(pfad, markierteZeile, 2)
 LV_getText(parameter, markierteZeile, 3)

;-- berprfen, ob schon ein geffnetes Fenster mit dem Parameter "name" existiert, wenn ja das offene Fenster aktivieren
;-- dies verhindert, dass Programme wie der Thunderbird versehentlich geffnet werden, auerdem kann man so sehr schnell das jeweilige Programm in den Vordergrund bringen, wenns mal unbersichtlich wird
;-- dies impliziert, dass als "Name" auch ein Wort gewhlt wird, welches im Fenstertitel des jeweiligen Programms vorkommt, sonst funktionierts natrlich nicht
StringUpper, nameUpper, name, t   ;-- Anfangsbuchstaben in groe Buchstaben wandeln
ifWinExist, %name%
WinActivate, %name%
else
{
ifWinExist, %nameUpper%
WinActivate, %nameUpper%
else   ;-- wenn das Programm nicht offen war
 run, "%pfad%" %parameter%
}
}
exitapp
return

ButtonNeu:
;-- ein Programm zur Liste hinzufgen
FileSelectFile, neuerPfad, , ::{20d04fe0-3aea-1069-a2d8-08002b30309d}, , Ausfhrbare Dateien (*.exe)
if(neuerPfad != "")
{  ;-- wenn ein gltiger Pfad gewhlt wurde
 loop
 {
  inputbox, bezeichner, , Name eingeben:
  if(bezeichner != "")
   break
 }
 inputbox, parameter, , Parameter eingeben (optional):
 fileappend, %bezeichner%|%neuerPfad%|%parameter%`n, %pfad_eintraege%
 listeAktualisieren(pfad_eintraege)
}
return

ButtonLschen:
;-- Programm aus der Liste entfernen
markierteZeile := LV_getNext()
if(markierteZeile <= 0)
 msgbox, 0, Fehler beim Lschen, Nichts markiert.
else
{
 LV_getText(pfad, markierteZeile, 2)
 eintragAusListeEntfernen(pfad_eintraege, pfad_backup, pfad)
 listeAktualisieren(pfad_eintraege)
}
return


;-- funktionen
listeAktualisieren(pfad_eintraege)
{
LV_Delete()   ;-- clear list
loop, read, %pfad_eintraege%
{ ;-- inhalt der datei zeile fr zeile
StringSplit, pfad_array, A_LoopReadLine, |
IfExist, %pfad_array2%   ;-- wenn es den pfad gibt
{
 LV_Add(zero, pfad_array1, pfad_array2, pfad_array3)   ;-- fge ihn hinzu
}   ;-- if
} ;-- loop
LV_ModifyCol()   ;-- Spaltenbreite anpassen
GuiControl, focus, liste   ;-- Tastaturfokus auf die liste setzen
return
} ;-- Ende von Methode listeAktualisieren

eintragAusListeEntfernen(pfad_eintraege, pfad_backup, pfad)
{
;-- alle Eintrge, die nicht dem zu lschenden Pfad entsprechen werden in eine Backupdatei geschrieben
;-- anschlieend wird die Backupdatei in die Datei "pfade.ini" umbenannt
loop, read, %pfad_eintraege%
{  ;-- inhalt der datei zeile fr zeile
StringSplit, pfad_array, A_LoopReadLine, |
if(pfad_array2 != pfad)   ;-- wenn aktueller Pfad nicht der zu lschende ist
 fileAppend, %A_LoopReadLine%`n, %pfad_backup%   ;-- belasse ihn in der Liste
}
filedelete, %pfad_eintraege%
filemove, %pfad_backup%, %pfad_eintraege%,1
return
}
